<template>
  <div class="app-container">
    <el-form :model="queryParams" ref="queryForm" size="small" :inline="true" v-show="showSearch" label-width="68px">
      <el-form-item label="泊位名称" prop="berthName">
        <el-input
          v-model="queryParams.berthName"
          placeholder="请输入泊位名称"
          clearable
          @keyup.enter.native="handleQuery"
        />
      </el-form-item>
      <el-form-item>
        <el-button type="primary" icon="el-icon-search" size="mini" @click="handleQuery">搜索</el-button>
        <el-button icon="el-icon-refresh" size="mini" @click="resetQuery">重置</el-button>
      </el-form-item>
    </el-form>

    <el-row :gutter="10" class="mb8">
      <el-col :span="1.5">
        <el-button
          type="primary"
          plain
          icon="el-icon-plus"
          size="mini"
          @click="handleAdd"
          v-hasPermi="['jxc:berth:add']"
        >新增
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="success"
          plain
          icon="el-icon-edit"
          size="mini"
          :disabled="single"
          @click="handleUpdate"
          v-hasPermi="['jxc:berth:edit']"
        >修改
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="danger"
          plain
          icon="el-icon-delete"
          size="mini"
          :disabled="multiple"
          @click="handleDelete"
          v-hasPermi="['jxc:berth:remove']"
        >删除
        </el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="info"
          plain
          icon="el-icon-upload2"
          size="mini"
          @click="handleImport"
          v-hasPermi="['jxc:berth:import']"
        >导入</el-button>
      </el-col>
      <el-col :span="1.5">
        <el-button
          type="warning"
          plain
          icon="el-icon-download"
          size="mini"
          @click="handleExport"
          v-hasPermi="['jxc:berth:export']"
        >导出
        </el-button>
      </el-col>
      <right-toolbar :showSearch.sync="showSearch" @queryTable="getList"></right-toolbar>
    </el-row>

    <el-table v-loading="loading" :data="berthList" @sort-change="handleSortChange"
              @selection-change="handleSelectionChange">
      <el-table-column type="selection" width="55" align="center"/>
      <el-table-column label="泊位代码" align="center" prop="berthCode" sortable='custom'/>
      <el-table-column label="泊位名称" align="center" prop="berthName" sortable='custom'/>
      <el-table-column label="所属港口名称" align="center" prop="portName" sortable='custom'/>
      <el-table-column label="所属港口公司" align="center" prop="companyId" sortable='custom' :formatter="deptFormatter"/>
      <el-table-column fixed="right" label="操作" align="center" class-name="small-padding fixed-width" width="120px">
        <template slot-scope="scope">
          <el-button
            size="mini"
            type="text"
            icon="el-icon-edit"
            @click="handleUpdate(scope.row)"
            v-hasPermi="['jxc:berth:edit']"
          >修改
          </el-button>
          <el-button
            size="mini"
            type="text"
            icon="el-icon-delete"
            @click="handleDelete(scope.row)"
            v-hasPermi="['jxc:berth:remove']"
          >删除
          </el-button>
        </template>
      </el-table-column>
    </el-table>

    <pagination

      :total="total"
      :page.sync="queryParams.pageNum"
      :limit.sync="queryParams.pageSize"
      @pagination="getList"
    />

    <!-- 添加或修改泊位信息对话框 -->
    <el-dialog :title="title" :visible.sync="open" width="80%" append-to-body :close-on-click-modal="false">
      <el-form ref="form" :model="form" :rules="rules" label-width="160px" v-enterboard>
        <el-row>
          <el-col :span="8">
            <el-form-item label="泊位代码" prop="berthCode">
              <el-input v-model="form.berthCode" placeholder="请输入泊位代码"/>
            </el-form-item>
          </el-col>
          <el-col :span="8">
            <el-form-item label="泊位名称" prop="berthName">
              <el-input v-model="form.berthName" placeholder="请输入泊位名称"/>
            </el-form-item>
          </el-col>

          <el-col :span="8">
            <el-form-item label="所属港口" prop="port">
              <el-select v-model="form.port" filterable placeholder="请输入所属港口" style="width: 100%" clearable
                         @change="setPortDetail">
                <el-option v-for="item in portList" :key="item.id" :label="item.portName" :value="item.id" >
                </el-option>
              </el-select>
            </el-form-item>
          </el-col>
        </el-row>
        <el-row>
          <el-col :span="8">
            <el-form-item label="所属港口公司" prop="companyId">
              <treeselect v-model="form.companyId" :options="deptOptions" :show-count="true"
                          placeholder="请选择所属港口公司"/>
            </el-form-item>
          </el-col>
        </el-row>
      </el-form>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitForm">确 定</el-button>
        <el-button @click="cancel">取 消</el-button>
      </div>
    </el-dialog>

    <!-- 导入对话框 -->
    <el-dialog :title="upload.title" :visible.sync="upload.open" width="400px" append-to-body>
      <el-upload
        ref="upload"
        :limit="1"
        accept=".xlsx, .xls"
        :headers="upload.headers"
        :action="upload.url + '?updateSupport=' + upload.updateSupport"
        :disabled="upload.isUploading"
        :on-progress="handleFileUploadProgress"
        :on-success="handleFileSuccess"
        :auto-upload="false"
        drag
      >
        <i class="el-icon-upload"></i>
        <div class="el-upload__text">将文件拖到此处，或<em>点击上传</em></div>
        <div class="el-upload__tip text-center" slot="tip">
          <div class="el-upload__tip" slot="tip">
            <el-checkbox v-model="upload.updateSupport" /> 是否更新已经存在的泊位信息数据
          </div>
          <span>仅允许导入xls、xlsx格式文件。</span>
          <el-link type="primary" :underline="false" style="font-size:12px;vertical-align: baseline;" @click="importTemplate">下载模板</el-link>
        </div>
      </el-upload>
      <div slot="footer" class="dialog-footer">
        <el-button type="primary" @click="submitFileForm">确 定</el-button>
        <el-button @click="upload.open = false">取 消</el-button>
      </div>
    </el-dialog>
  </div>
</template>


<script>
import {pageListBerth, getBerth, delBerth, addBerth, updateBerth} from "@/api/jxc/berth";
import {listPort,} from "@/api/jxc/port";
import {listDept} from "../../../api/system/dept";
import {deptTreeSelect} from "@/api/system/user";
import Treeselect from "@riophae/vue-treeselect";
import "@riophae/vue-treeselect/dist/vue-treeselect.css";
import {getToken} from "@/utils/auth";

export default {
  name: "Berth",
  components: {Treeselect},
  data() {
    return {
      // 遮罩层
      loading: true,
      // 选中数组
      ids: [],
      // 选中名字
      names: [],
      // 非单个禁用
      single: true,
      // 非多个禁用
      multiple: true,
      // 显示搜索条件
      showSearch: true,
      // 总条数
      total: 0,
      // 部门树选项
      deptOptions: [],
      deptList: [],
      // 客户表格数据
      custList: [],
      // 港口表格数据
      portList: [],
      // 泊位信息表格数据
      berthList: [],
      // 弹出层标题
      title: "",
      // 是否显示弹出层
      open: false,
      // 查询参数
      queryParams: {
        pageNum: 1,
        pageSize: 10,
        berthCode: null,
        berthName: null,
        port: null,
        companyId: null,
        portName: null,
        portCode: null,
      },
      // 表单参数
      form: {},
      // 导入参数
      upload: {
        // 是否显示弹出层
        open: false,
        // 弹出层标题
        title: "",
        // 是否禁用上传
        isUploading: false,
        // 是否更新已经存在的数据
        updateSupport: 0,
        // 设置上传的请求头部
        headers: { Authorization: "Bearer " + getToken() },
        // 上传的地址
        url: process.env.VUE_APP_BASE_API + "/jxc/berth/importData"
      },
      // 表单校验
      rules: {
        berthCode: [
          {required: true, message: "泊位代码不能为空", trigger: "blur"},
        ],
        berthName: [
          {required: true, message: "泊位名称不能为空", trigger: "blur"},
        ],
        port: [
          {required: true, message: "所属港口不能为空", trigger: "blur"},
        ],
        companyId: [
          {required: true, message: "所属港口公司不能为空", trigger: "blur"},
        ],
      }
    };
  },
  created() {
    this.getList();
    this.getPortList();
    this.getDeptTree();
    listDept({}).then(response => {
      this.deptList = response.data;
    });
  },
  methods: {
    /** 查询部门下拉树结构 */
    getDeptTree() {
      deptTreeSelect().then(response => {
        this.deptOptions = response.data;
      });
    },
    deptFormatter(row, column, cellValue, index) {
      //console.log("cellValue", cellValue);
      const obj = this.deptList.find((obj) => obj.deptId == cellValue)
      //console.log("obj", obj);
      return obj ? obj.deptName : cellValue
    },


    setPortDetail(portId) {
      //console.log(portId);
      this.portList.forEach(ele => {
        if (ele.id === portId) {
          //console.log("aa:", ele.portName);
          this.form.portName = ele.portName;
          this.form.portCode = ele.portCode;
        }
      })
    },

    getPortList() {
      let param = {};
      listPort(param).then(response => {
        this.portList = response.data;
      }).catch(e => {
      });
    },


    /** 查询泊位信息列表 */
    getList() {
      this.loading = true;
      pageListBerth(this.queryParams).then(response => {
        this.berthList = response.rows;
        this.total = response.total;
        this.loading = false;
      }).catch(e => {
        this.loading = false;
      });
    },
    // 取消按钮
    cancel() {
      this.open = false;
      this.reset();
    },
    // 表单重置
    reset() {
      this.form = {
        id: null,
        berthCode: null,
        berthName: null,
        port: null,
        companyId: null,
        remark: null,
        portName: null,
        portCode: null,
      };
      this.resetForm("form");
    },
    //排序
    handleSortChange(col) {
      this.$sortBy(col, this.queryParams);
      this.getList();
    },
    /** 搜索按钮操作 */
    handleQuery() {
      this.queryParams.pageNum = 1;
      this.getList();
    },
    /** 重置按钮操作 */
    resetQuery() {
      this.resetForm("queryForm");
      this.handleQuery();
    },
    // 多选框选中数据
    handleSelectionChange(selection) {
      this.ids = selection.map(item => item.id);
      this.names = selection.map(item => item.id);
      this.single = selection.length !== 1;
      this.multiple = !selection.length;
    },
    /** 新增按钮操作 */
    handleAdd() {
      this.reset();
      this.open = true;
      this.title = "添加泊位信息";
    },
    /** 修改按钮操作 */
    handleUpdate(row) {
      this.reset();
      const id = row.id || this.ids;
      getBerth(id).then(response => {
        this.form = response.data;
        this.open = true;
        this.title = "修改泊位信息";
      });
    },
    /** 提交按钮 */
    submitForm() {
      this.$refs["form"].validate(valid => {
        if (valid) {
          if (this.form.id != null) {
            updateBerth(this.form).then(response => {
              this.$modal.msgSuccess("修改成功");
              this.open = false;
              this.getList();
            });
          } else {
            addBerth(this.form).then(response => {
              this.$modal.msgSuccess("新增成功");
              this.open = false;
              this.getList();
            });
          }
        }
      });
    },
    /** 删除按钮操作 */
    handleDelete(row) {
      const ids = row.id || this.ids;
      const names = row.id || this.names;
      this.$modal.confirm('是否确认删除"' + row.berthCode + "-"+ row.berthName + '"的数据项？').then(function () {
        return delBerth(ids);
      }).then(() => {
        this.getList();
        this.$modal.msgSuccess("删除成功");
      }).catch(() => {
      });
    },
    /** 导入按钮操作 */
    handleImport() {
      this.upload.title = "泊位信息导入";
      this.upload.open = true;
    },
    /** 下载模板操作 */
    importTemplate() {
      const fileName = `泊位信息模板_${new Date().getTime()}.xlsx`;
      this.download(`jxc/berth/importTemplate`, {}, fileName);
    },

    // 文件上传中处理
    handleFileUploadProgress(event, file, fileList) {
      this.upload.isUploading = true;
    },
    // 文件上传成功处理
    handleFileSuccess(response, file, fileList) {
      this.upload.open = false;
      this.upload.isUploading = false;
      this.$refs.upload.clearFiles();
      this.$alert("<div style='overflow: auto;overflow-x: hidden;max-height: 70vh;padding: 10px 20px 0;'>" + response.msg + "</div>", "导入结果", { dangerouslyUseHTMLString: true });
      this.getList();
    },
    // 提交上传文件
    submitFileForm() {
      this.$refs.upload.submit();
    },
    /** 导出按钮操作 */
    handleExport() {
      this.download('jxc/berth/export', {
        ...this.queryParams
      }, `泊位信息_${new Date().getTime()}.xlsx`)
    }
  }
};
</script>
